;;;; -*- Mode: Lisp -*-
;;;; $Id: usocket-clozure.lisp 588 2008-10-28 10:40:33Z binghe $

(in-package :usocket)

(defun socket-connect/udp (host port &key element-type timeout deadline nodelay
			   local-host local-port)
  (declare (ignore element-type timeout deadline nodelay))
  (with-mapped-conditions ()
    (let ((mcl-sock
	   (openmcl-socket:make-socket :address-family :internet
				       :type :datagram
				       :local-host (when local-host (host-to-hostname local-host))
				       :local-port local-port
                                       :format :binary)))
      (when (and host port)
	(ccl::inet-connect (ccl::socket-device mcl-sock)
			   (ccl::host-as-inet-host host)
			   (ccl::port-as-inet-port port "udp")))
      (make-datagram-socket mcl-sock))))

(defmethod socket-send ((usocket datagram-usocket) buffer length &key host port)
  (with-mapped-conditions (usocket)
    (openmcl-socket:send-to (socket usocket) buffer length
			    :remote-host (host-to-hbo host)
			    :remote-port port)))

(defmethod socket-receive ((usocket datagram-usocket) buffer length)
  (with-mapped-conditions (usocket)
    (openmcl-socket:receive-from (socket usocket) length :buffer buffer)))
