;;;; -*- Mode: Lisp -*-
;;;; $Id: usocket-sbcl.lisp 750 2009-02-11 03:33:41Z binghe $

(in-package :usocket)

(defun socket-connect/udp (host port &key element-type timeout deadline nodelay
			                  local-host local-port)
  (declare (ignore element-type timeout deadline nodelay))
  (let ((socket (make-instance 'sb-bsd-sockets:inet-socket
			       :type :datagram :protocol :udp)))
    (handler-case
	(progn
	  (when (or local-host local-port)
	    (sb-bsd-sockets:socket-bind socket
					(host-to-vector-quad
					 (or local-host *wildcard-host*))
					(or local-port *auto-port*)))
	  (when (and host port)
	    (sb-bsd-sockets:socket-connect socket (host-to-vector-quad host) port))
	  (make-datagram-socket socket))
      (t (c)
        ;; Make sure we don't leak filedescriptors
        (sb-bsd-sockets:socket-close socket)
        (error c)))))

(defmethod socket-send ((socket datagram-usocket) buffer length &key host port)
  (with-mapped-conditions (socket)
    (let* ((s (socket socket))
           (dest (if (and host port) (list (host-to-vector-quad host) port) nil)))
      (sb-bsd-sockets:socket-send s buffer length :address dest))))

(defmethod socket-receive ((socket datagram-usocket) buffer length
			   &key (element-type '(unsigned-byte 8)))
  (with-mapped-conditions (socket)
    (let ((s (socket socket)))
      (sb-bsd-sockets:socket-receive s buffer length :element-type element-type))))
